<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="用印人" prop="employeeName">
        <el-input v-model="queryParams.employeeName" placeholder="请输入用印人" clearable style="width: 250px"
                  @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item label="部门" prop="deptId">
        <treeselect style="width: 250px" :default-expand-level="1" v-model="queryParams.deptId" :options="deptOptions" :normalizer="normalizer" placeholder="选择部门" />
      </el-form-item>
      <el-form-item label="职位" prop="position">
        <el-select v-model="queryParams.position" placeholder="请选择"
        style="width: 250px">
          <el-option v-for="item in posOptions" :key="item.value" :label="item.label" :value="item.value">
          </el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="手机号" prop="employeePhone">
        <el-input v-model="queryParams.employeePhone" placeholder="请输入手机号" clearable style="width: 250px"
                  @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item label="用印标题" prop="stampTitle">
        <el-input v-model="queryParams.stampTitle" placeholder="请输入用印标题" clearable style="width: 250px"
                  @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item label="状态" prop="auditStatus">
        <el-select v-model="queryParams.auditStatus" placeholder="审批状态" clearable style="width: 250px">
          <el-option v-for="dict in this.getDictDatas(DICT_TYPE.BPM_TASK_AUDIT_STATUS)" :key="parseInt(dict.value)" :label="dict.label" :value="parseInt(dict.value)"/>
        </el-select>
      </el-form-item>
      <el-form-item label="申请时间" prop="createTime">
            <el-date-picker v-model="queryParams.createTime" style="width: 250px" value-format="yyyy-MM-dd HH:mm:ss"
              type="daterange" range-separator="-" start-placeholder="开始日期" end-placeholder="结束日期"
              :default-time="['00:00:00', '23:59:59']" />
          </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd"
          v-hasPermi="['stamp:list:create']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
          <el-button type="warning" icon="el-icon-download" size="mini" @click="handleExport" :loading="exportLoading"
                     v-hasPermi="['stamp:list:export']">导出</el-button>
        </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="StampList">
      <el-table-column label="用印人" align="center" prop="employeeName" min-width="100" />
      <el-table-column label="部门" align="center" prop="deptName" min-width="100" />
      <el-table-column label="职位" align="center" prop="position" min-width="100" />
      <el-table-column label="手机号" align="center" prop="employeePhone" min-width="100" />
      <el-table-column label="用印标题" align="center" prop="stampTitle" min-width="150" />
      <el-table-column label="创建人" align="center" prop="currentAuditEmployeeName" min-width="100" />
      <el-table-column label="状态" align="center" prop="status">
        <template v-slot="scope">
          <dict-tag :type="DICT_TYPE.COMMON_STATUS" :value="scope.row.status" />
        </template>
      </el-table-column>
      <el-table-column label="创建时间"  align="center" prop="createTime" min-width="180">
        <template v-slot="scope">
          <span>{{ parseTime(scope.row.createTime) }}</span>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template v-slot="scope">
          <el-button size="mini" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)"
            v-hasPermi="['stamp:list:update']">修改</el-button>
          <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)"
            v-hasPermi="['stamp:list:delete']">删除</el-button>
          <el-button size="mini" type="text" icon="el-icon-detail" @click="handleDetail(scope.row)"
            v-hasPermi="['stamp:list:detail']">详情</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNo" :limit.sync="queryParams.pageSize"
      @pagination="getList" />

    <!-- 添加或修改对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="800px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
      <el-form-item label="离职人" prop="employeeName">
        <el-input v-model="form.employeeName" placeholder='点击选择' readonly @click.native="openSingle"></el-input>
      </el-form-item>
      <el-form-item label="离职人Id" style="display: none;">
        <el-input v-model="form.employeeId" placeholder='离职人Id' disabled></el-input>
      </el-form-item>
      <el-form-item label="部门">
        <el-input v-model="form.deptName" placeholder='部门' disabled></el-input>
      </el-form-item>
      <el-form-item label="职位">
        <el-input v-model="form.position" placeholder='职位' disabled></el-input>
      </el-form-item>
       <el-form-item label="手机号">
        <el-input v-model="form.employeePhone" placeholder='手机号' disabled></el-input>
      </el-form-item>
      <el-form-item label="用印标题" prop="stampTitle">
        <el-input maxlength="20" v-model="form.stampTitle" placeholder='请输入申请的简要标题'></el-input>
      </el-form-item>
      <el-form-item label="用章类型" prop="stampSealId">
        <el-checkbox-group v-model="form.stampSealId">
          <el-checkbox v-for="item in oaStampSeal" :label="item.id" :key="item.id">{{item.sealName}}</el-checkbox>
        </el-checkbox-group>
      </el-form-item>
      <el-form-item label="用印事由" prop="reason">
        <el-input maxlength="50" show-word-limit type="textarea" v-model="form.reason"
          placeholder='请输入用印事由'></el-input>
      </el-form-item>
      <el-form-item label="附件">
        <el-upload :action="fileUrl" :headers="headers" :file-list="files" :on-success="handleFileSuccessCite"
          :before-upload="beforeUploadFile" :on-remove="handleRemove">
          <el-button size="small" type="primary">点击上传</el-button>
        </el-upload>
      </el-form-item>
      <el-form-item label="备注">
        <el-input maxlength="200" rows="4" show-word-limit type="textarea" v-model="form.remarks" placeholder="请输入备注" />
      </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
    <!-- 详情对话框 -->
    <el-dialog :title="title" :visible.sync="openDetail" width="800px" append-to-body>
      <div class="widget-wrapper">
        <div class="widget-list" v-loading="loading">
          <div class="fx-field x-grid-col-12">
        <div class="field-label">
          <div class="field-name">用印人</div>
        </div>
        <div class="field-component">
          <span :title="form.loginName">{{ form.employeeName }}</span>
        </div>
      </div>
      <div class="fx-field x-grid-col-12">
        <div class="field-label">
          <div class="field-name">部门</div>
        </div>
        <div class="field-component">
          <span :title="form.deptName">{{ form.deptName }}</span>
        </div>
      </div>
      <div class="fx-field x-grid-col-12">
        <div class="field-label">
          <div class="field-name">职位</div>
        </div>
        <div class="field-component">
          <span :title="form.position">{{ form.position }}</span>
        </div>
      </div>
    
      <div class="fx-field x-grid-col-12">
        <div class="field-label">
          <div class="field-name">手机号</div>
        </div>
        <div class="field-component">
          <span :title="form.employeePhone">{{ form.employeePhone }}</span>
        </div>
      </div>
      <div class="fx-field x-grid-col-12">
        <div class="field-label">
          <span class="field-required">*</span>
          <div class="field-name">用印标题</div>
        </div>
        <div class="field-component">
          <span :title="form.stampTitle">{{ form.stampTitle }}</span>
        </div>
      </div>

      <div class="fx-field x-grid-col-12">
        <div class="field-label">
          <span class="field-required">*</span>
          <div class="field-name">用章类型</div>
        </div>
        <div class="field-component">
          <el-checkbox-group v-model="form.stampSealId">
            <el-checkbox v-for="item in oaStampSeal" :label="item.id" :key="item.id" disabled>{{item.sealName}}</el-checkbox>
          </el-checkbox-group>
        </div>
      </div>

      <div class="fx-field x-grid-col-12">
        <div class="field-label">
          <span class="field-required">*</span>
          <div class="field-name">用印事由</div>
        </div>
        <div class="field-component">
          <span :title="form.reason">{{ form.reason }}</span>
        </div>
      </div>
        </div>
      </div>
    </el-dialog>
    <PeopleSelect ref="peopleSelect" type="single" :isCheck="true" :open="singlePeopleOpen"
    @cancel="singlePeopleOpen = false" @submit="submitSingle"></PeopleSelect>
  </div>
</template>

<script>
import { listStamp, getStamp, delStamp, addStamp, updateStamp, exportStamp } from "@/api/stamp/list";
import { typeList } from "@/api/oa/stamp"
import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";
import PeopleSelect from "@/components/PeopleSelect/index.vue";
import { DICT_TYPE } from '@/utils/dict'
import { listDept } from "@/api/system/dept";
import { getBaseHeader } from "@/utils/request";
export default {
  name: "SystemStamp",
  components: {
    PeopleSelect,
    Treeselect,
  },
  data() {
    return {
      oaStampSeal:[
      ],
      posOptions:[],
       // 部门列表
       deptOptions: [], // 部门属性结构
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 岗位表格数据
      StampList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      openDetail: false,
      // 查询参数
      queryParams: {
        pageNo: 1,
        pageSize: 10,
        employeeName: undefined,
        deptId: undefined,
        position: undefined,
        employeePhone: undefined,
        stampTitle: undefined,
        auditStatus: undefined,
        createTime: []
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        employeeName: [
          { required: true, message: '请选择', trigger: 'change' },
        ],
        stampTitle: [
          { required: true, message: '请输入申请的简要标题', trigger: 'blur' },
        ],
        stampSealId: [
          { required: true, message: '请选择印章类型', trigger: 'blur' },
        ],
        reason: [
          { required: true, message: '请输入详细描述', trigger: 'blur' }
        ],
      },
      files: [],
      // 设置上传的请求头部
      headers: getBaseHeader(),
      // 上传的地址
      fileUrl: process.env.VUE_APP_BASE_API + '/admin-api/infra/file/uploaData',
      singlePeopleOpen: false,
    };
  },
  created() {
    this.getList();
    this.getListDept();
    this.getTypeList();
  },
  methods: {
     // 类型信息列表
     getTypeList(){
      typeList().then(
        response => {
          this.oaStampSeal = response.data;
        }
      );
    },
     /** 查询部门列表 */
     getListDept() {
      listDept().then(response => {
        this.deptOptions = this.handleTree(response.data, "id");
      });
    },
    /** 转换部门数据结构 */
    normalizer(node) {
      if (node.children && !node.children.length) {
        delete node.children;
      }
      return {
        id: node.id,
        label: node.name,
        children: node.children
      };
    },
      //打开选人弹窗
      openSingle() {
      this.singlePeopleOpen = true;
    },
    submitSingle(userNamelist, nikeNamelist,userIdList) {
      console.log(userNamelist);
      this.form.employeeName = nikeNamelist.join();
      this.form.employeeId = userIdList.join();
      this.singlePeopleOpen = false;
    },
    /** 查询岗位列表 */
    getList() {
      this.loading = true;
      listStamp(this.queryParams).then(response => {
        this.StampList = response.data.list;
        this.total = response.data.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        employeeName: undefined,
        deptName: undefined,
        position: undefined,
        employeePhone: undefined,
        stampTitle: undefined,
        stampSealId: [],
        reason: undefined,
        fileIdList: undefined,
        remarks: undefined,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNo = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加岗位";
    },
    handleRemove(file, fileList) {
      console.log(file, fileList);
      let fileIds = [];
      for (let i in fileList) {
        let id = fileList[i].response.data.id;
        fileIds.push(id);
      }
      this.form.fileIdList = fileIds;
    },
    beforeUploadFile(file) {
      console.log(file);
      const size = file.size / 1024 / 1024;
      console.log(size);
      if (size > 5) {
        this.$message.error("文件大小不能超过5MB！");
        return false;
      }
    },
    handleFileSuccessCite(res, file, fileList) {
      console.log(file, fileList);
      console.log("------", "==========");
      console.log("res = ", res);

      let fileIds = [];
      for (let i in fileList) {
        let response = fileList[i].response;
        if (response.errno && response.errno != "0") {
          this.$message.error("该文件上传失败,已被移除,请重新上传!");
          // 上传失败移除该 file 对象
          fileList.splice(i, 1);
        } else {
          let id = fileList[i].response.data.id;
          fileIds.push(id);
        }
      }
      this.form.fileIdList = fileIds;
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id
      getStamp(id).then(response => {
        this.form = response.data;
        let files = response.data.fileList;
        if (files) {
          this.files = [];
          for (let i in files) {
            let url = files[i].url;
            let name = files[i].name;
            let id = files[i].id;

            this.files.push({
              name: name,
              url: url,
              response: { error: "0", data: { url: url, id: id } },
            });
          }
        }
        this.open = true;
        this.title = "修改岗位";
      });
    },
    /** 详情按钮操作 */
    handleDetail(row) {
      this.reset();
      const id = row.id
      getStamp(id).then(response => {
        this.form = response.data;
        this.openDetail = true;
        this.title = "详情";
      });
    },

    /** 提交按钮 */
    submitForm: function () {
      console.log(this.form);
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id !== undefined) {
            updateStamp(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addStamp(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id;
      this.$modal.confirm('是否确认删除岗位编号为"' + ids + '"的数据项?').then(function () {
        return delStamp(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => { });
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$modal.confirm('是否确认导出所有岗位数据项?').then(() => {
        this.exportLoading = true;
        return exportStamp(queryParams);
      }).then(response => {
        this.$download.excel(response, '岗位数据.xls');
        this.exportLoading = false;
      }).catch(() => { });
    }
  }
};
</script>
<style lang="scss" scoped>
.user-avatar {
  width: 22px;
  height: 22px;
  line-height: 19px;
  font-size: 12px;
  background: #46c26f;
  border: 1px solid transparent;
  border-radius: 50%;
  color: #fff;
  display: inline-block;
  overflow: hidden;
  text-align: center;
  vertical-align: middle;
  margin-bottom: 2px;
}

.el-tag+.el-tag {
  margin-left: 10px;
}

.button-new-tag {
  margin-right: 10px;
  height: 30px;
  line-height: 30px;
  padding-top: 0;
  padding-bottom: 0;
}
.widget-wrapper>.widget-list {
  display: flex;
  flex-wrap: wrap;
}

.x-grid-col-6 {
  width: 50%;
}

.x-grid-col-12 {
  width: 100%;
}

.fx-field {
  line-height: 20px;
  padding: 7px 12px 12px;
  position: relative;
}

.fx-field .field-label {
  word-wrap: break-word;
  color: #141e31;
  display: flex;
  font-weight: 600;
  line-height: 20px;
  padding: 5px 0;
  position: relative;
  word-break: break-word;
}

.fx-field .field-label .field-required {
  color: #eb5050;
  margin-left: -6px;
  position: relative;
}

.fx-field .field-label .field-name {
  overflow: hidden;
}

.field-component {
  word-wrap: break-word;
  background: #f5f6f8;
  border-radius: 2px;
  color: #141e31;
  font-size: 14px;
  line-height: 20px;
  min-height: 32px;
  padding: 6px 8px;
  white-space: pre-wrap;
  word-break: break-word;
}

ul {
  padding-left: 0px !important;
}

.el-tag+.el-tag {
  margin-left: 10px;
}
</style>